<template>
  <div>
    <div class="form-wrap" @keyup.enter="signIn">
      <h2 class="is-capitalized">{{ $t('auth.signIn') }}</h2>
      <b-input v-model="signInEmail"
                type="email"
                placeholder="Email"
                icon="envelope"
                maxlength="30">
      </b-input>
      <b-input v-model="signInPassword"
                type="password"
                :placeholder="$t('auth.password')"
                icon="key"
                password-reveal
                maxlength="30">
      </b-input>
      <b-button class="is-capitalized"
                type="is-primary"
                @click="signIn">{{ $t('auth.submit') }}</b-button>
    </div>
    <div class="form-wrap" @keyup.enter="signUp">
      <h2 class="is-capitalized">{{ $t('auth.signUp') }}</h2>
      <b-input v-model="signUpEmail"
                type="email"
                placeholder="Email"
                icon="envelope"
                maxlength="30">
      </b-input>
      <b-input v-model="signUpPassword"
                type="password"
                :placeholder="$t('auth.password')"
                icon="key"
                password-reveal
                maxlength="30">
      </b-input>
      <b-button class="is-capitalized"
                type="is-primary"
                @click="signUp">{{ $t('auth.submit') }}</b-button>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { pick, capitalize } from 'lodash';
import { USER, AUTH } from '@/store';

@Component
export default class Auth extends Vue {
  signInEmail: string = '';
  signInPassword: string = '';
  signUpEmail: string = '';
  signUpPassword: string = '';

  signIn(): void {
    this.$http.post('auth/sign_in',{ email: this.signInEmail,
                                     password: this.signInPassword })
      .then((response) => {
        const authHeaders = pick(response.headers,
                                 ['access-token', 'client', 'expiry',
                                  'uid', 'token-type']);
        this.$store.commit(AUTH, authHeaders);
        this.$store.commit(USER, response.data.data);

        const contents = {
          tokens: authHeaders,
          user: response.data.data
        };

        this.$cookie.set('session',
                         JSON.stringify(contents),
                         { expires: '14D' });

        this.$router.push({ name: 'Me' });
        this.$buefy.toast.open({
          message: 'Hello :D',
          type: 'is-success'
        });
      })
      .catch((_e) => {
        this.$buefy.toast.open({
          message: capitalize(this.$t('auth.signInError')),
          type: 'is-danger'
        })
      });
  }

  signUp(): void {
    this.$http.post('auth', { email: this.signUpEmail,
                              password: this.signUpPassword })
      .then((response) => {
        this.signInEmail = this.signUpEmail;
        this.signInPassword = this.signUpPassword;
        this.signUpEmail = '';
        this.signUpPassword = '';
        this.$buefy.toast.open({
          message: capitalize(this.$t('auth.signUpSuccessful')),
          type: 'is-success'
        });
      })
      .catch((_e) => {
        this.$buefy.toast.open({
          message: capitalize(this.$t('auth.signUpError')),
          type: 'is-danger'
        })
      });
  }
}
</script>

<style lang="scss">
.form-wrap {
  margin: 1rem 0;
  &:first-of-type {
    padding-bottom: 1rem;
    border-bottom: $k-border;
  }
}
</style>
